package ru.landgrafhomyak.db.raw_sql_skeleton

public class Namespace(
	public val _name: String,
	private val path: Array<String>
) {
	private val usedNames = HashSet<String>()

	public fun subnamespace(name: String): Namespace {
		if (name in this.usedNames)
			throw IllegalArgumentException("Name is already used: $name")
		this.usedNames.add(name)
		return Namespace(name, this.path + this._name)
	}

	public fun table(name: String): Table {
		if (name in this.usedNames)
			throw IllegalArgumentException("Name is already used: $name")
		this.usedNames.add(name)

		return Table(this, this.formatTableName(name))
	}

	public val _path: List<String> = this.path.asList()
	private fun formatTableName(name: String) = this.path.joinToString(prefix = "::", separator = "::", postfix = "::${this._name}::${name}")
}